#ifndef		MENU_H
#define		MENU_H

#include "debug.h"
#include "gamescreen.h"
#include "menuitem.h"
#include <vector>

class Menu : public GameScreen {
	protected:
		std::vector<MenuItem *> items;
		unsigned int selectedItem;
	
	public:
		Menu();
		virtual ~Menu();

		virtual Error Init();
		virtual GameState NextState();
		virtual void Draw(BITMAP *canvas);
		virtual bool Update();
		virtual void AddItem(MenuItem *item);
		virtual void Clear();
		MenuItem *GetSelectedItem();
};

#endif		//MENU_H
